<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celtool/stdmsgchannel.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">celtool/stdmsgchannel.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2008 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_CELTOOL_STDMSGCHANNEL__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_CELTOOL_STDMSGCHANNEL__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/refarr_8h.html">csutil/refarr.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/weakref_8h.html">csutil/weakref.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/weakrefarr_8h.html">csutil/weakrefarr.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/hash_8h.html">csutil/hash.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;physicallayer/pl.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;physicallayer/messaging.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;celtool/celtoolextern.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">class </span>celMessageSubscription
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 <span class="keyword">public</span>:
<a name="l00034"></a>00034   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRef.html">csWeakRef&lt;iMessageReceiver&gt;</a> receiver;
<a name="l00035"></a>00035   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> mask;
<a name="l00036"></a>00036   <span class="keyword">inline</span> <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator&lt; (<span class="keyword">const</span> celMessageSubscription&amp; sub1,
<a name="l00037"></a>00037       <span class="keyword">const</span> celMessageSubscription&amp; sub2)
<a name="l00038"></a>00038   {
<a name="l00039"></a>00039     <span class="keywordflow">return</span> sub1.mask &lt; sub2.mask;
<a name="l00040"></a>00040   }
<a name="l00041"></a>00041 };
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">class </span>celMessageDispatcher : <span class="keyword">public</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfImplementation1.html">scfImplementation1</a>&lt;celMessageDispatcher,
<a name="l00044"></a>00044   iMessageDispatcher&gt;
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">private</span>:
<a name="l00047"></a>00047   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> msg_id;
<a name="l00048"></a>00048   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> message;
<a name="l00049"></a>00049   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRef.html">csWeakRef&lt;iMessageSender&gt;</a> sender;
<a name="l00050"></a>00050   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRefArray.html">csWeakRefArray&lt;iMessageReceiver&gt;</a> receivers;
<a name="l00051"></a>00051   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iMessageReceiverFilter&gt;</a> receiver_filter;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054   celMessageDispatcher (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> msg_id, <span class="keyword">const</span> <span class="keywordtype">char</span>* message,
<a name="l00055"></a>00055       <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* sender, <a class="code" href="structiMessageReceiverFilter.html" title="This is a filter used for a message dispatcher.">iMessageReceiverFilter</a>* receiver_filter)
<a name="l00056"></a>00056         : scfImplementationType (this),
<a name="l00057"></a>00057           msg_id (msg_id),
<a name="l00058"></a>00058           message (message),
<a name="l00059"></a>00059           sender (sender),
<a name="l00060"></a>00060           receiver_filter (receiver_filter) { }
<a name="l00061"></a>00061   <span class="keyword">virtual</span> ~celMessageDispatcher () { }
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SendMessage (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params, iCelDataArray* ret)
<a name="l00063"></a>00063   {
<a name="l00064"></a>00064     <span class="keywordtype">size_t</span> i = 0;
<a name="l00065"></a>00065     <span class="keywordtype">bool</span> handled = <span class="keyword">false</span>;
<a name="l00066"></a>00066     <span class="keywordflow">while</span> (i &lt; receivers.GetSize ())
<a name="l00067"></a>00067     {
<a name="l00068"></a>00068       <span class="keywordflow">if</span> (receivers[i])
<a name="l00069"></a>00069       {
<a name="l00070"></a>00070         <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> ret1;
<a name="l00071"></a>00071         <span class="keywordtype">bool</span> rc = receivers[i]-&gt;ReceiveMessage (msg_id, sender, ret1, params);
<a name="l00072"></a>00072         <span class="keywordflow">if</span> (rc)
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074           handled = <span class="keyword">true</span>;
<a name="l00075"></a>00075           <span class="keywordflow">if</span> (ret1.type != CEL_DATA_NONE &amp;&amp; ret) ret-&gt;Push (ret1);
<a name="l00076"></a>00076         }
<a name="l00077"></a>00077         i++;
<a name="l00078"></a>00078       }
<a name="l00079"></a>00079       <span class="keywordflow">else</span>
<a name="l00080"></a>00080       {
<a name="l00081"></a>00081         receivers.DeleteIndex (i);
<a name="l00082"></a>00082       }
<a name="l00083"></a>00083     }
<a name="l00084"></a>00084     <span class="keywordflow">return</span> handled;
<a name="l00085"></a>00085   }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> GetMessageID ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> msg_id; }
<a name="l00088"></a>00088   <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; GetMessage ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> message; }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> AddReceiver (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>* receiver);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordtype">void</span> RemoveReceiver (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>* receiver)
<a name="l00093"></a>00093   {
<a name="l00094"></a>00094     <span class="keywordtype">size_t</span> i = 0;
<a name="l00095"></a>00095     <span class="keywordflow">while</span> (i &lt; receivers.GetSize ())
<a name="l00096"></a>00096     {
<a name="l00097"></a>00097       <span class="keywordflow">if</span> (receivers[i] == receiver)
<a name="l00098"></a>00098         receivers.DeleteIndex (i);
<a name="l00099"></a>00099       <span class="keywordflow">else</span>
<a name="l00100"></a>00100         i++;
<a name="l00101"></a>00101     }
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* GetSender ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> sender; }
<a name="l00105"></a>00105 };
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="comment">// SafeCopyElementHandler has to be used here, as otherwise the weakref&#39;s in</span>
<a name="l00108"></a>00108 <span class="comment">// the celMessageSubscription get memcopyed and thats not allowed.</span>
<a name="l00109"></a>00109 <span class="keyword">typedef</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">csHash&lt;celMessageSubscription,csPtrKey&lt;iMessageReceiver&gt;</a>,
<a name="l00110"></a>00110         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classCS_1_1Memory_1_1AllocatorMalloc.html">CS::Memory::AllocatorMalloc</a>, 
<a name="l00111"></a>00111         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArraySafeCopyElementHandler.html">csArraySafeCopyElementHandler</a>&lt; 
<a name="l00112"></a>00112                 <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classCS_1_1Container_1_1HashElement.html">CS::Container::HashElement</a>&lt;celMessageSubscription,
<a name="l00113"></a>00113                 <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtrKey.html">csPtrKey&lt;iMessageReceiver&gt;</a> &gt; &gt; &gt;
<a name="l00114"></a>00114   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celSubscriptions</a>;
<a name="l00115"></a>00115 
<a name="l00121"></a><a class="code" href="classcelMessageChannel.html">00121</a> <span class="keyword">class </span>CEL_CELTOOL_EXPORT <a class="code" href="classcelMessageChannel.html" title="Helper class for a message channel.">celMessageChannel</a> : <span class="keyword">public</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfImplementation1.html">scfImplementation1</a>&lt;
<a name="l00122"></a>00122                                              celMessageChannel, iMessageChannel&gt;
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124 <span class="keyword">private</span>:
<a name="l00125"></a>00125   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRef.html">csWeakRef&lt;iCelPlLayer&gt;</a> pl;
<a name="l00126"></a>00126   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray&lt;celMessageDispatcher&gt;</a> messageDispatchers;
<a name="l00127"></a>00127   celSubscriptions messageSubscriptions;
<a name="l00128"></a>00128 <span class="keyword">public</span>:
<a name="l00129"></a>00129   <a class="code" href="classcelMessageChannel.html" title="Helper class for a message channel.">celMessageChannel</a> () : scfImplementationType (<span class="keyword">this</span>) { }
<a name="l00130"></a>00130   <span class="keyword">virtual</span> ~<a class="code" href="classcelMessageChannel.html" title="Helper class for a message channel.">celMessageChannel</a> () { RemoveMessageDispatchers (); }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <a class="code" href="structiMessageChannel.html" title="This is an message channel.">iMessageChannel</a>* QueryMessageChannel ()
<a name="l00133"></a>00133   {
<a name="l00134"></a>00134     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="structiMessageChannel.html" title="This is an message channel.">iMessageChannel</a>*<span class="keyword">&gt;</span> (<span class="keyword">this</span>);
<a name="l00135"></a>00135   }
<a name="l00137"></a>00137   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iMessageDispatcher&gt;</a> CreateMessageDispatcher (
<a name="l00138"></a>00138       <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* sender, <span class="keyword">const</span> <span class="keywordtype">char</span>* msg_id,
<a name="l00139"></a>00139       <a class="code" href="structiMessageReceiverFilter.html" title="This is a filter used for a message dispatcher.">iMessageReceiverFilter</a>* receiver_filter = 0);
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> RemoveMessageDispatcher (<a class="code" href="structiMessageDispatcher.html" title="This is a message dispatcher.">iMessageDispatcher</a>* msgdisp);
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> Subscribe (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>* receiver, <span class="keyword">const</span> <span class="keywordtype">char</span>* mask);
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> Unsubscribe (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>* receiver, <span class="keyword">const</span> <span class="keywordtype">char</span>* mask = 0);
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SendMessage (<span class="keyword">const</span> <span class="keywordtype">char</span>* msgid,
<a name="l00144"></a>00144       <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* sender, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params,
<a name="l00145"></a>00145       iCelDataArray* ret = 0);
<a name="l00146"></a>00146   <span class="keywordtype">void</span> RemoveMessageDispatchers ();
<a name="l00147"></a>00147   <span class="keywordtype">void</span> SetPL (<a class="code" href="structiCelPlLayer.html" title="This is the Physical Layer itself.">iCelPlLayer</a>* pl) { celMessageChannel::pl = pl; }
<a name="l00148"></a>00148 };
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="preprocessor">#endif // __CEL_CELTOOL_STDMSGCHANNEL__</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
